#include <algorithm>
#include <iostream>
#include "GUIScreen.h"

// Abstract AGuiScreen definition

gui::AGUIScreen::AGUIScreen() {
    std::cout << "Hello form AGUIScreen" << "\n";
    this->widgets = std::vector<AGUIWidget*>();
}

int gui::AGUIScreen::update() {
    std::sort(widgets.begin(), widgets.end(), [](AGUIWidget* aWidget, AGUIWidget* bWidget) {
        return aWidget->getLayer() < bWidget->getLayer();
    });
    for (auto *widget: widgets) {
        widget->update();
    }
    return (0);
}

int gui::AGUIScreen::addWidget(gui::AGUIWidget *widget) {
    this->widgets.push_back(widget);
    return 0;
}

int gui::AGUIScreen::removeWidget(gui::AGUIWidget *_widget) {
    return 0;
}

int gui::AGUIScreen::removeWidget(int _index) {
    return 0;
}

int gui::AGUIScreen::removeWidget(const char *_name) {
    return 0;
}

std::vector<gui::AGUIWidget*> gui::AGUIScreen::getWidgets() const {
    return this->widgets;
}


// DefaultGuiScreen definition

gui::DefaultGuiScreen::DefaultGuiScreen() {
    std::cout << "Hello form DefaultGuiScreen" << "\n";
}

int gui::DefaultGuiScreen::setup() {
    return 0;
}

const char *gui::DefaultGuiScreen::getName() const {
    return "DefaultGuiScreen";
}
